;; declare original Variables
(declare-fun a1 () (_ Float 8 23))
(declare-fun a2 () (_ Float 8 23))
(declare-fun a3 () (_ Float 8 23))
(declare-fun a4 () (_ Float 8 23))
;; declare lower and upper value for range
(define-fun lower () Int 1065353216)
(define-fun higher () Int 1317011456)
;; range constraints for original variables
(define-fun r1 () Bool (and (fplt a1 ((_ fpnum 8 23) higher)) (fplt ((_ fpnum 8 23) lower) a1)))
(define-fun r2 () Bool (and (fplt a2 ((_ fpnum 8 23) higher)) (fplt ((_ fpnum 8 23) lower) a2)))
(define-fun r3 () Bool (and (fplt a3 ((_ fpnum 8 23) higher)) (fplt ((_ fpnum 8 23) lower) a3)))
(define-fun r4 () Bool (and (fplt a4 ((_ fpnum 8 23) higher)) (fplt ((_ fpnum 8 23) lower) a4)))
;; assert range constraints for original variables
(assert (and r1 r2 r3 r4))
;; define lhs: accumulation
(define-fun new () (_ Float 8 23) (fpadd fp_round_zero (fpadd fp_round_zero (fpadd fp_round_zero a1 a2) a3) a4))
;; define rhs: reduction
(define-fun new1 () (_ Float 8 23) (fpadd fp_round_zero (fpadd fp_round_zero a1 a2) (fpadd fp_round_zero a3 a4)))
;; range constraints for lhs and rhs
(define-fun rnew () Bool (and (fplt new ((_ fpnum 8 23) higher)) (fplt ((_ fpnum 8 23) lower) new)))
(define-fun rnew1 () Bool (and (fplt new1 ((_ fpnum 8 23) higher)) (fplt ((_ fpnum 8 23) lower) new1)))
;; assert range constraints for lhs and rhs
(assert (and rnew rnew1))
;; Define skeleton, assert it, check for sat
;(define-fun skeleton () Bool (not (fpeq new new1)))
;(define-fun pos1 () Bool (fpgt a1 ((_ fpnum 8 23) 0)))
;(define-fun pos2 () Bool (fpgt a2 ((_ fpnum 8 23) 0)))
;(define-fun pos3 () Bool (fpgt a3 ((_ fpnum 8 23) 0)))
;(define-fun pos4 () Bool (fpgt a4 ((_ fpnum 8 23) 0)))

;(assert (and pos1 pos2 pos3 pos4))
(define-fun delta () Int 925353388); This is FP rep of 0.00001 as a 4-byte unsigned Integer
(define-fun skeleton () Bool (fpgt new1 (fpadd fp_round_zero new ((_ fpnum 8 23) delta))))
(assert skeleton)
(check-sat)
